// * This code is licensed under:
// * JRunMC License, Version 1.0
// * - for license details see http://runmc.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by S.Chekanov (chekanov@mail.desy.de). 
// * All rights reserved.

package JRunMC.ui;

import JRunMC.util.*;
import JRunMC.web.*;

// set preferences for RMC info file
import java.io.*;
import java.util.*;
import java.util.prefs.*;
import java.text.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

   public class  GUIwebLoader{

   private static String loca=""; 
   private static Vector<String> rmc;
   private static String path="";

 public static void init(){

     rmc = new Vector<String>();

     path=SetEnv.RUNDIR;
     if (SetEnv.OSsys.equals("windows") ) path=SetEnv.RUNDIRwin32;

     loca=path+File.separator+SetEnv.WEBFILES+File.separator+"rmcmodules.html";




     new Thread1("Loading files from the web");
// show message
    showMess.display();

   }




// start loading 
private static void start(){


   // get index file 
   copyRMC.getfile("JRunMC.jar");
   Global.mainFrame.OpenRMCfile("Copying JRunMC.jar file ..");


// give some time
   try {
   Thread.sleep(10);
    } catch (Exception err) { }



      Global.mainFrame.ShowMess( "Updating JRunMC.jar from HEPforge WWW");

      String ss="Connecting to http://hepforge.cedar.ac.uk/runmc <br>"; 
      ss=ss+"<b>Wait..</b><br>";


      String ok="<H2><font color=\"blue\"><b>JRunMC.jar has been loaded!</H2></font>";
      ss= ok+"<b>You should exit this window and restart JRunMC</b>";  

// correct the string at the end
      String line=StringUtil.replace(ss,"<b>Wait..</b><br>", "");
      line=StringUtil.replace(line,"Connecting to http://hepforge.cedar.ac.uk/runmc <br>", "");
      showMess.settext(line);


// copy all the files
     String in1=path+File.separator+SetEnv.WEBFILES+File.separator+"JRunMC.jar";
     String out1=path+File.separator+"main"+File.separator+"jrunmc"+File.separator+"JRunMC.jar";
     File f1= new File(in1); 
     File f2= new File(out1);
     if (f1.exists()) {
     try { Utility.copy(f1,f2); }  catch (IOException e) { System.out.print("Error when copy the file"); } ;
     }


    } // end of start 
 


public static class  showMess{



         public static HtmlBrowserDialog mess;
    
         private  static void display() {   

         mess = new HtmlBrowserDialog(Global.mainFrame, "Connection to HEPforge", true );
         mess.setText( "Loading files from HEPforge.." );

         //   viewer.htmlPane.setPreferredSize( new Dimension(200,300) );
 // Get the system resolution
          Dimension res = Toolkit.getDefaultToolkit().getScreenSize();
   // make sure the dialog is not too big
          Dimension size = new Dimension(Math.min(500,res.width),
                        Math.min(300, res.height) );
          mess.setSize(size);
          Util.centreWithin ( Global.mainFrame, mess );
          mess.showthis();

         } 

          public  static void settext(String ss ) {
            mess.setText( ss );
          }


        public  static void setcaretEnd() {
              mess.setCaretEnd();
          }


   } // end show message  


 

// making titles of dictionaries  and booting databases
private  static class Thread1 implements Runnable {
 Thread t;
 Thread1(String s1) {
       t= new Thread (this,s1);
       t.start();
 }

   public void run() {
      start();
   }
 } // end Thread3



   
 } 

                  
                  
 
