CDECK  ID>, HWDHWT.
*CMZ :-        -26/06/01  14.44.53  by  Stefano Moretti
*-- Author :    Stefano Moretti
C-----------------------------------------------------------------------
      FUNCTION HWDHWT(EMSQ,DUMMYA,DUMMYB,DUMMYC)
C-----------------------------------------------------------------------
C     MATRIX ELEMENT SQUARED FOR
C     ((V-A)*TB1+(V+A)*CT1)*((V-A)*TB2+(V+A)*CT2)) WEAK DECAY
C-----------------------------------------------------------------------
      INCLUDE 'HERWIG65.INC'
      COMMON/FFS/TB,BT
      COMMON/SFF/IT1,IB1,IT2,IB2
      DOUBLE PRECISION TB,BT
      INTEGER IT1,IB1,IT2,IB2
      DOUBLE PRECISION TBH,HBT,CB1,TB1,CB2,TB2
      DOUBLE PRECISION DUMMYA,DUMMYB,DUMMYC
      DOUBLE PRECISION HWDHWT,EMSQ
      CB1=RMASS(IT1)**2
      TB1=RMASS(IB1)**2
      CB2=RMASS(IT2)**2
      TB2=RMASS(IB2)**2
C use formula (4.52) page 217 of `Higgs Hunter Guide'.
      TBH=(TB1+CB1-EMSQ)*(TB1*TB*TB+CB1/TB/TB)+4.*TB1*CB1
C use formula (B. 1) page 411 of `Higgs Hunter Guide'.
      HBT=(EMSQ-TB2-CB2)*(TB2*BT*BT+CB2/BT/BT)-4.*TB2*CB2
      HWDHWT=TBH*HBT
      HWDHWT=ABS(HWDHWT)*SQRT(EMSQ)
      END
