
      SUBROUTINE GENFIL

*#**********************************************************************
*#
*#    SUBROUTINE GENFIL
*#
*# PURPOSE: fill all GENOUT commons to interface generator output with
*#          GENOUT which creates the generator bos banks
*#
*# CALLED BY:
*#
*# CALLING:
*#
*# AUTHOR: Guenter Grindhammer      CREATED AT: 91/05/27
*#
*# CHANGED BY:                              AT:
*# REASON:
*#
*#**********************************************************************

#include "h1mcutil/comdef/cbosmdl.inc"



      IF (BEGJOB) THEN

C---fill genout common cgvrs
         CALL GRAVRS(1)
         CALL GPYVRS(2)

C---COPY UPDATED PARAMETERS OF A GENERATOR MODULE (RAPGAP)
C   fill genout common cgpar
         CALL GRAPAR

C---fill genout common cgen to be able to create HEAR bank for the
C   begin run record (this call must be before the first call to GENOUT.
         CALL GRAGEN

C---CREATE AND ADD BANK(S) OF PARAMETERS FOR A GENERATOR MODULE (RAPGAP)
C   and bank GCM_ to list 'E' for output to tape and to the database.
C   in addition add bank GSTX to list 'E' for output to tape.
         CALL GENOUT

C---copy updated parameters of a generator module (ARIADNE)
C   fill genout common cgpar
ccc         CALL GARPAR

C---create and add bank(s) of parameters for a generator module (ARIADNE)
C   and bank GCM_ to list 'E' for output to tape and to the database.
C   in addition add bank GSTX to list 'E' for output to tape.
cc         CALL GENOUT

C---copy updated parameters of a generator module (JETSET/PYTHIA)
C   fill genout common cgpar
         CALL GPYPAR

C---create and add bank(s) of parameters for a generator module (JETSET)
C   to list 'E' for output to tape and to the database.
         CALL GENOUT

      ENDIF
c      write(6,*) ' genfil '
      IF (REVENT) THEN

C---fill the COMMON /HEPEVT/ for GENOUT
         CALL PYHEPC(1)

C---fill genout common cgen
         CALL GRAGEN

C---fill genout common cgki
         CALL GRAGKI

C---fill genout common cgevc
         CALL GRAEVC

C---create generator banks HEAD, GHD_, GKI_, GTR_, and GVX_
C   and add them to list 'E' for output to tape.
C   for the first event add bank GHD_ to the database.
         CALL GENOUT

      ENDIF

      IF (ENDJOB) THEN

C---fill genout common cgend
         CALL GRAEND

C---create bank GEND and add it to list 'E' for output to tape and
C   to database
         CALL GENOUT

      ENDIF

      RETURN
      END

