      PROGRAM RGMAIN
	Implicit None
#include "rgfull.inc"
#include "rgdisdif.inc"
C---initialise JETSET 7.3 parameters
#include "rgluco.inc"
#include "rgludat1.inc"
#include "rgpara.inc"
#include "rgpypars.inc"
#include "rgdiffr.inc"
#include "rgscq2.inc"
#include "rglq2.inc"
      Integer IVM
      COMMON/VMESON/IVM
      Double Precision PYPAR,PYVAR
      Integer IPY
      COMMON /RGPYPARA/ IPY(80),PYPAR(80),PYVAR(80)
      Integer ICOLORA,IRESPRO,IRPA,IRPB,IRPC,IRPD,IRPE,IRPF,IRPG
      COMMON /COLCON/ ICOLORA,IRESPRO,IRPA,IRPB,IRPC,IRPD,IRPE,IRPF,IRPG
C SEQUENCES FOR HERACLES.
      Double Precision THEMIN,CTHMIN,CTHCON
      COMMON /HSTCUT/ THEMIN,CTHMIN,CTHCON
#include "rghsunts.inc"
#include "rghsoptn.inc"
#include "rghscuts.inc"
#include "rghsvglp.inc"
      Integer LPAR,LPARIN,IPART
      COMMON /HSPARL/ LPAR(20),LPARIN(12),IPART
      REAL*4 PAR111,PAR112,PARL11,PARL19
      INTEGER MST111,MST115
	COMMON /HSALFS/ PAR111,PAR112,PARL11,PARL19,MST111,MST115
	Integer Nevent
	Common/steer1/Nevent
      Integer N1,N2

	real timeleft
      Integer Minuts
      External Minuts
	External pydata

      Integer I,ISEED
C---initialise ARIADNE parameters, now done via block data
C---initialise PYTHIA 6 parameters
c      CALL GPYINI
C pythia block data taken via external statement
         write(6,*) ' grapga: PYTHIA block data taken '
C     initialize random number generator
      ISEED = 213123
      ISEED = Iabs(MINUTS())
      N1 = 0
      N2 = 0
      CALL RM48IN(ISEED,N1,N2)
C---initialise RAPGAP parameters
      CALL GRAINI
C-- read in parameters from file 
      Call Steer
C-- change standard parameters of RAPGAP 	
	Call rapcha
C-- change standard parameters of HERACLES	
	Call hercha
C-- change standard parameters of JETSET
	Call pytcha
      call pylogo
C-- change standard parameters of ARIADNE
	Call aricha
	
C Initialize ARIADNE
      CALL ARINIT('RAPGAP')
C-- change standard parameters of ARIADNE
	Call aricha
C--- CALCULATE X SECTION
      CALL PTIME(' rapgap  ',1,0)
      CALL RAPGAP
C--- print x section
      CALL RAEND(1)
C--- event generation
      DO 10 I=1,Nevent
         CALL PTIME(' event  ',1,0)
#if ( defined(timelim) )
	   call timel(timeleft)
	   if(timeleft.le.10.) then
	      write(6,*) ' *** time limit reached. time left = ',timeleft
            goto 123
	   endif
#endif
         CALL EVENT
C--- user analysis routine
c         CALL ANALYS
C--- user analysis routine (hztool)
cc         CALL hzraana
      CALL PTIME(' event  ',2,0)
C---
   10 CONTINUE
123   Continue
C---PRINT NR OF GENERATED EVENTS
      CALL RAEND(20)	
C--- user terminate routine (hztool)
cc	CALL hzraend
	
      CALL PTIME(' rapgap  ',2,0)
      CALL PTIME('        ',2,99)
      STOP
      END

