// * This code is licensed under:
// * RunMC License, Version 1.0
// * - for license details see http://runmc.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by S.Chekanov (chekanov@mail.desy.de).
// * All rights reserved.

// get all calculated value into the histogram
using namespace std;
#include<iostream>
#include<heplist.h>
#include<stdlib.h>
#include<stdio.h>

extern heplist hep;      // get particles after the cuts


// ----------------------- Fill stable hadrons 
void PrintList() {

// print list of particles for this event


// fill histgrams for each particles
  cout << " " << endl;
  cout << "->RunMC event record with  " << hep.PP.size() << " particles" << endl;
  cout << " No       Name   Id      Px       Py       Pz      E    Charge" << endl;   
  cout << " -------------------------------------------------------------" << endl;
  for  (unsigned int nn=0; nn < hep.PP.size(); nn++ ) {         // run over all particles
  printf("%3d %10s %5d %8.2f %8.2f %8.3f %8.3f %3d\n",nn,hep.PP[nn].name(),hep.PP[nn].id,hep.PP[nn].p.px(),
  hep.PP[nn].p.py(),hep.PP[nn].p.pz(),hep.PP[nn].p.e(),hep.PP[nn].charge3/3);
  } // end loop over all particles

}
