// * This code is licensed under:
// * JRunMC License, Version 1.0
// * - for license details see http://runmc.sourceforge.net/License.txt
// *
// * Copyright (c) 2005 by S.Chekanov (chekanov@mail.desy.de). 
// * All rights reserved.

package JRunMC.ui;

import JRunMC.util.*;
import JRunMC.web.*;

// set preferences for RMC info file
import java.io.*;
import java.util.*;
import java.util.prefs.*;
import java.text.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

   public class  RMCwebLoader{

   private static String loca=""; 
   private static Vector<String> rmc;
   private static String path="";

 public static void init(){

     rmc = new Vector<String>();

     path=SetEnv.RUNDIR;
     if (SetEnv.OSsys.equals("windows") ) path=SetEnv.RUNDIRwin32;

     loca=path+File.separator+SetEnv.WEBFILES+File.separator+"rmcmodules.html";




     new Thread1("Loading files from the web");
// show message
    showMess.display();

   }




// start loading 
private static void start(){


   // get index file 
   copyRMC.getfile("rmcmodules.html");
   Global.mainFrame.OpenRMCfile("Copying index file ..");


// give some time
   try {
   Thread.sleep(100);
    } catch (Exception err) { }


   File ff = new File( loca );
   if (ff.exists()) {

   try {
   String s=null;
   FileReader inF = new FileReader(ff);
          BufferedReader br = new BufferedReader(inF);
          while (( s=br.readLine())!= null) {
             int i0=s.indexOf("\"");
             int i1=s.indexOf(".rmc");
             int i2=s.indexOf("archive");
             if (i0>-1 && i1>-1 && i2>-1) {
                     String s1=s.substring(i0+1,i1);
                     String s2=StringUtil.replace(s1,"archive"+File.separator, "");
                     rmc.add(s2+".rmc");
                //     System.out.println(s1);
         }
       } // end while loop

          inF.close();

          }catch (IOException et) {}

  }


      Global.mainFrame.ShowMess( "Updating files from HEPforge WWW");

      String ss="Connecting to http://hepforge.cedar.ac.uk/runmc <br>"; 
      String tot="Total number of available RMC modules is <b>"+ Integer.toString(rmc.size())+"</b><br>";
      ss=ss+tot+"<b>Wait..</b><br>";

// copy all the files
     for (int i=0; i<rmc.size();  i++) {
         String s0="archive"+File.separator+(String)rmc.elementAt(i);
         String snum=Integer.toString(i+1)+") ";
         ss=ss+snum+" Loading "+s0+"<br>"; 
         showMess.settext(ss);
         copyRMC.getfile(s0);
     }

      String ok="<H2><font color=\"blue\"><b>All RMC have been loaded!</H2></font>";
      ss= ok+"<b>You can exit this window</b><br>"+ss+"<br><b>All done!</b>";  

// correct the string at the end
      String line=StringUtil.replace(ss,"<b>Wait..</b><br>", "");
      line=StringUtil.replace(line,"Connecting to http://hepforge.cedar.ac.uk/runmc <br>", "");
      line=StringUtil.replace(line,"Loading", "Loaded");
      showMess.settext(line);



// copy all the files
     for (int i=0; i<rmc.size();  i++) {

     String in1=path+File.separator+SetEnv.WEBFILES+File.separator+(String)rmc.elementAt(i);
     String out1=path+File.separator+"archive"+File.separator+(String)rmc.elementAt(i);
  //   System.out.println("INPUT="+in1);
  //   System.out.println("OUTPUT="+out1);

     File f1= new File(in1); 
     File f2= new File(out1);
     try { Utility.copy(f1,f2); }  catch (IOException e) { System.out.print("Error when copy the file"); } ;
     }


    } // end of start 
 


public static class  showMess{



         public static HtmlBrowserDialog mess;
    
         private  static void display() {   

         mess = new HtmlBrowserDialog(Global.mainFrame, "Connection to HEPforge", true );
         mess.setText( "Loading files from HEPforge.." );

         //   viewer.htmlPane.setPreferredSize( new Dimension(200,300) );
 // Get the system resolution
          Dimension res = Toolkit.getDefaultToolkit().getScreenSize();
   // make sure the dialog is not too big
          Dimension size = new Dimension(Math.min(500,res.width),
                        Math.min(300, res.height) );
          mess.setSize(size);
          Util.centreWithin ( Global.mainFrame, mess );
          mess.showthis();

         } 

          public  static void settext(String ss ) {
            mess.setText( ss );
          }


        public  static void setcaretEnd() {
              mess.setCaretEnd();
          }


   } // end show message  


 

// making titles of dictionaries  and booting databases
private  static class Thread1 implements Runnable {
 Thread t;
 Thread1(String s1) {
       t= new Thread (this,s1);
       t.start();
 }

   public void run() {
      start();
   }
 } // end Thread3



   
 } 

                  
                  
 
