C
C
      SUBROUTINE DTRANS(XO,YO,ZO,CDE,SDE,CFE,SFE,X,Y,Z)
C***********************************************************************
C
C     actualized version of Oct. 1992
C
C***********************************************************************
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      SAVE
C
      PARAMETER(TINY=1.D-08,TINY2=1.D-30,ONE=1.D0)
C
      AX=ABS(XO)
      AY=ABS(YO)
      IF(AX.LT.AY) THEN
        AMAX=AY
        AMIN=AX
      ELSE
        AMAX=AX
        AMIN=AY
      ENDIF
      IF (ABS(XO)-TINY) 1,1,2
    1 IF (ABS(YO)-TINY) 3,3,2
C
    3 CONTINUE
C     WRITE(6,*)' DTRANS XO YO ZO =',XO,YO,ZO
      X=SDE*CFE
      Y=SDE*SFE
      Z=CDE*ZO
C     WRITE(6,*)' DTRANS X=SDE*CFE Y=SDE*SFE Z=CDE'
C     WRITE(6,*) X,Y,Z
      RETURN
C
    2 CONTINUE
      IF(AMAX.GT.TINY2) THEN
        AR=AMIN/AMAX
        AR=AR*AR
        A=AMAX*SQRT(ONE+AR)
      ELSE
C       WRITE(6,*)' DTRANS AMAX LE TINY2 '
        GOTO 3
      ENDIF
      XI=SDE*CFE
      YI=SDE*SFE
      ZI=CDE
      X=-YO*XI/A-ZO*XO*YI/A+XO*ZI
      Y=XO*XI/A-ZO*YO*YI/A+YO*ZI
      Z=A*YI+ZO*ZI
      END
