*CMZ :  0.02/00 02/05/91  12.40.41  by  M. Erdmann
*-- Author :    M. Erdmann   25/04/91
         SUBROUTINE QHBKOU
C--------------------------------------------------------------------
C
C    HBOOK: QHBKOU: termination, called at endjob
C
C  DATACARDS:
C
C*********** print HBOOK histograms:
C
C  HBKPRI    1st-histogram-id      last-histogram-id
C
C        M. Erdmann
C
C--------------------------------------------------------------------
      INTEGER      NHROW,NHCOL,NHLEN
      PARAMETER   (NHROW = 2, NHCOL = 1, NHLEN=2)
      INTEGER      NBOSIW
      PARAMETER   (NBOSIW=1000000)
      INTEGER      IW(NBOSIW)
      REAL         RW(NBOSIW)
      COMMON /BCS/ IW
      EQUIVALENCE (RW(1),IW(1))
      SAVE   /BCS/
* NHBOOK : memory space for HBOOK
* HRFTOP : name of the top directory of the direct access file
* MPRHIS : max. number of histograms
*
         INTEGER         NHBOOK
         PARAMETER      (NHBOOK = 1000000)
         REAL            H
         COMMON /PAWC/ H(NHBOOK)
         CHARACTER*6     HRFTOP
         PARAMETER      (HRFTOP ='HISTO')
         INTEGER         MPRHIS
         PARAMETER      (MPRHIS = 10000)
         LOGICAL         HBKOUT
         COMMON /QHBKLO/ HBKOUT
C        PARAMETER  (NRECL=6*1024)
         PARAMETER  (NRECL=1024)
c         PARAMETER  (NRECL=4096)
         CHARACTER   HRFMOD*2,CHAINT*4,FILNAM*72
C         COMMON/QUEST/IQUEST(100)
        DATA        HRFMOD / 'N' /
c         DATA        HRFMOD / 'NQ' /
         Integer IERR
         DATA        IOWRIT /  6  /
         SAVE
c         INCLUDE 'bcs.inc'
c         INCLUDE 'qhbook.inc'
*
         INTEGER    IDVECT(MPRHIS)

* >>> HBOOK: HBKPRI card, print histgrams

 1000 FORMAT(1X,'QHBKOU: no HBKPRI card to print HBOOK histograms')
         IND = IW(NAMIND('HBKP'))
         IF(IND.GT.0) THEN
            IFIRST= IW(IND+1)
            ILAST = IW(IND+2)
         ELSE
            WRITE(IOWRIT,1000)
            GOTO 2000
         END IF

 1001 FORMAT(1X,'QHBKOU: bad first=',I8,' or last=',I8,' HBKPRI card')
         IF  ((IFIRST .LE. 0 .AND. ILAST .LE. 0)
     +   .OR.  IFIRST .GT. ILAST ) THEN
               WRITE(IOWRIT,1001) IFIRST,ILAST
               GOTO 2000
         ENDIF

 1002 FORMAT(1X,'QHBKOU: bad number of existing histgrams=',I8)
         CALL HIDALL(IDVECT,NHIS)
         IF ( NHIS .LE. 0 .OR. MPRHIS .LT. NHIS ) THEN
               WRITE(IOWRIT,1002) NHIS
               GOTO 2000
         ENDIF

 1003 FORMAT(1X,'QHBKOU: existing histo-id [',I8,',',I8,']',
     +     ' do not match with HBKPRI card [',I8,',',I8,']')
         CALL INTSOR(IDVECT,NHIS)
         IF  ( ILAST .LT. IDVECT(1)
     +   .OR.             IDVECT(NHIS) .LT. IFIRST ) THEN
               WRITE(IOWRIT,1003) IDVECT(1),IDVECT(NHIS),IFIRST,ILAST
               GOTO 2000
         ENDIF

* >>> all histograms

         IF  ( IFIRST .LE. IDVECT(1)
     +   .AND.             IDVECT(NHIS) .LE. ILAST ) THEN
               CALL HISTDO
               GOTO 2000
         ENDIF

* >>> selected histograms

 1004 FORMAT(1X,'QHBKOU: first histogram above lower HBKPRI card=',I8,
     +         ' is out of the HBKPRI range [',I8,',',I8,']')
         ILOW  = 1
         IHIGH = NHIS
         DO 100 I=1, NHIS
            IF ( IFIRST .LE. IDVECT(I) ) THEN
                 ILOW  = I
                 GOTO 101
            ENDIF
  100    CONTINUE
  101    IF ( IDVECT(ILOW) .GT. ILAST ) THEN
              WRITE(IOWRIT,1004) IDVECT(ILOW),IFIRST,ILAST
              GOTO 2000
         ENDIF

 1005 FORMAT(1X,'QHBKOU: no histogram in the range of the HBKPRI card',
     +                                              ' [',I8,',',I8,']')
         DO 200 I=ILOW, NHIS
            IF ( ILAST  .EQ. IDVECT(I) ) THEN
                 IHIGH = I
                 GOTO 201
            ENDIF
            IF ( ILAST  .LT. IDVECT(I) ) THEN
                 IHIGH = I-1
                 GOTO 201
            ENDIF
  200    CONTINUE
  201    IF ( ILOW .GT. IHIGH ) THEN
              WRITE(IOWRIT,1005) IDVECT(ILOW),IFIRST,ILAST
              GOTO 2000
         ENDIF

         DO 300 I=ILOW, IHIGH
            CALL HPRINT(IDVECT(I))
  300    CONTINUE

* >>> HBOOK: PAW output file

 2000    IF (.NOT.HBKOUT) GOTO 9999
         CALL HROUT(0,ICYCLE,'T')
         CALL HREND(HRFTOP)

 9999    RETURN
         END
